/***********************************************************
* Artsoft Retro-Game Library                               *
*----------------------------------------------------------*
*               Artsoft Entertainment                      *
*               Holger Schemel                             *
*               Detmolder Strasse 189                      *
*               33604 Bielefeld                            *
*               Germany                                    *
*               e-mail: info@artsoft.org                   *
*----------------------------------------------------------*
* zurl.h                                                   *
*----------------------------------------------------------*
* (c) by the owner of the alias/nickname "HerzAusGold"     *
*               e-mail: herzausgold@online.de              *
***********************************************************/

#ifndef ZURL_H_
#define ZURL_H_

#define ZURLSETUP_FILENAME  "zurl.conf"
#define ZURL_TOKEN_PROXY    "zurl_proxy"
#define ZURL_TOKEN_DEBUG    "zurl_debug"

#define ZURL_DEBUGFILE      1
#define ZURL_FINDFILENAME   2

typedef struct zurl_header_s {
// general
    long  m_mode;
    char **m_pfilename;  // pointer to real filename pointer
} zurl_header_t;

typedef struct zurl_debug_s {
// general
    FILE *m_dbgfile;
} zurl_debug_t;


typedef struct zurl_s {
// general
    char *m_file_url;
    char *m_proxy_url;
    long  m_use_post;
    char *m_post_fields;
// options and flags
    long  m_optConnectTimeout;
    long  m_optBuffersize;
    long  m_optLowSpeedLimit;
    long  m_optLowSpeedTime;
    long  m_flagFreshConnect;
    long  m_flagAutoReferer;
    long  m_flagFollowLocation;
// for the file
    long  m_resume;  
    char *m_pathname;
    char *m_filename;
    char *m_fullfilename;
    FILE *m_savefile;
// for debugging
    long  m_verbose;
    long  m_progress;
    long  m_debug;
    void *m_debugData;
// for header 
    void *m_headerData;
} zurl_t;


int zurl_easyGet(zurl_t *zu);

int zurl_get(char *logdir, char *dir, char *url, 
             char *proxy, long debug,
             char **pFilename); 

int zurl_confget(char *basedir, char *levdir, char *confurl,
                 char **pFilename);


#endif  // ZURL_H

